3 # Copyright (c) 2005 Junio C Hamano
6 # if --tee was passed, write the output not only to the terminal, but
7 # additionally to the file test-results/$BASENAME.out, too.
8 case "$GIT_TEST_TEE_STARTED, $* " in
10 # do not redirect again
12 *' --tee '*|
*' --va'*)
14 BASE
=test-results
/$
(basename "$0" .sh
)
15 (GIT_TEST_TEE_STARTED
=done ${SHELL-sh} "$0" "$@" 2>&1;
16 echo $?
> $BASE.
exit) |
tee $BASE.out
17 test "$(cat $BASE.exit)" = 0
22 # Keep the original TERM for say_color
25 # For repeatability, reset the environment to known value.
31 export LANG LC_ALL PAGER TERM TZ
38 unset COMMIT_AUTHOR_EMAIL
39 unset COMMIT_AUTHOR_NAME
41 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
43 GIT_AUTHOR_EMAIL
=author@example.com
44 GIT_AUTHOR_NAME
='A U Thor'
45 unset GIT_COMMITTER_DATE
46 GIT_COMMITTER_EMAIL
=committer@example.com
47 GIT_COMMITTER_NAME
='C O Mitter'
51 unset GIT_EXTERNAL_DIFF
53 unset GIT_OBJECT_DIRECTORY
54 unset GIT_CEILING_DIRECTORIES
55 unset SHA1_FILE_DIRECTORIES
56 unset SHA1_FILE_DIRECTORY
58 export GIT_MERGE_VERBOSITY
59 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
60 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
62 GIT_TEST_CMP
=${GIT_TEST_CMP:-diff -u}
64 # Protect ourselves from common misconfiguration to export
65 # CDPATH into the environment
68 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
70 echo "* warning: Some tests will not work if GIT_TRACE" \
71 "is set as to trace on STDERR ! *"
72 echo "* warning: Please set GIT_TRACE to something" \
73 "other than 1, 2 or true ! *"
77 # Each test should start with something like this, after copyright notices:
79 # test_description='Description of this test...
80 # This test checks if command xyzzy does the right thing...
83 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
84 TERM
=$ORIGINAL_TERM &&
87 tput bold
>/dev
/null
2>&1 &&
88 tput setaf
1 >/dev
/null
2>&1 &&
89 tput sgr0
>/dev
/null
2>&1
96 -d|
--d|
--de|
--deb|
--debu|
--debug)
98 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
100 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
101 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
102 -h|
--h|
--he|
--hel|
--help)
104 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
106 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
113 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
114 valgrind
=t
; verbose
=t
; shift ;;
116 shift ;; # was handled already
118 echo "error: unknown test option '$1'" >&2; exit 1 ;;
122 if test -n "$color"; then
128 error
) tput bold
; tput setaf
1;; # bold red
129 skip
) tput bold
; tput setaf
2;; # bold green
130 pass
) tput setaf
2;; # green
131 info
) tput setaf
3;; # brown
132 *) test -n "$quiet" && return;;
142 test -z "$1" && test -n "$quiet" && return
149 say_color error
"error: $*"
158 test "${test_description}" != "" ||
159 error
"Test script did not set test_description."
161 if test "$help" = "t"
163 echo "$test_description"
168 if test "$verbose" = "t"
172 exec 4>/dev
/null
3>/dev
/null
183 if test -n "$GIT_EXIT_OK"
187 echo >&5 "FATAL: Unexpected exit with code $code"
195 # The semantics of the editor variables are that of invoking
196 # sh -c "$EDITOR \"$@\"" files ...
198 # If our trash directory contains shell metacharacters, they will be
199 # interpreted if we just set $EDITOR directly, so do a little dance with
200 # environment variables to work around this.
202 # In particular, quoting isn't enough, as the path may contain the same quote
207 VISUAL
='"$FAKE_EDITOR"'
212 if test -z "${test_tick+set}"
216 test_tick
=$
(($test_tick + 60))
218 GIT_COMMITTER_DATE
="$test_tick -0700"
219 GIT_AUTHOR_DATE
="$test_tick -0700"
220 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
223 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
225 # This will commit a file with the given contents and the given commit
226 # message. It will also add a tag with <message> as name.
228 # Both <file> and <contents> default to <message>.
232 echo "${3-$1}" > "$file" &&
235 git commit
-m "$1" &&
239 # Call test_merge with the arguments "<message> <commit>", where <commit>
240 # can be a tag pointing to the commit-to-merge.
244 git merge
-m "$1" "$2" &&
248 # This function helps systems where core.filemode=false is set.
249 # Use it instead of plain 'chmod +x' to set or unset the executable bit
250 # of a file in the working directory and add it to the index.
254 git update-index
--add "--chmod=$@"
257 # Use test_set_prereq to tell that a particular prerequisite is available.
258 # The prerequisite can later be checked for in two ways:
260 # - Explicitly using test_have_prereq.
262 # - Implicitly by specifying the prerequisite tag in the calls to
263 # test_expect_{success,failure,code}.
265 # The single parameter is the prerequisite tag (a simple word, in all
266 # capital letters by convention).
269 satisfied
="$satisfied$1 "
273 test_have_prereq
() {
282 # You are not expected to call test_ok_ and test_failure_ directly, use
283 # the text_expect_* functions instead.
286 test_success
=$
(($test_success + 1))
287 say_color
"" " ok $test_count: $@"
291 test_failure
=$
(($test_failure + 1))
292 say_color error
"FAIL $test_count: $1"
294 echo "$@" |
sed -e 's/^/ /'
295 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
298 test_known_broken_ok_
() {
299 test_fixed
=$
(($test_fixed+1))
300 say_color
"" " FIXED $test_count: $@"
303 test_known_broken_failure_
() {
304 test_broken
=$
(($test_broken+1))
305 say_color skip
" still broken $test_count: $@"
309 test "$debug" = "" ||
eval "$1"
319 test_count
=$
(($test_count+1))
321 for skp
in $GIT_SKIP_TESTS
323 case $this_test.
$test_count in
328 if test -z "$to_skip" && test -n "$prereq" &&
329 ! test_have_prereq
"$prereq"
335 say_color skip
>&3 "skipping test: $@"
336 say_color skip
"skip $test_count: $1"
345 test_expect_failure
() {
346 test "$#" = 3 && { prereq
=$1; shift; } || prereq
=
348 error
"bug in the test script: not 2 or 3 parameters to test-expect-failure"
351 say
>&3 "checking known breakage: $2"
353 if [ "$?" = 0 -a "$eval_ret" = 0 ]
355 test_known_broken_ok_
"$1"
357 test_known_broken_failure_
"$1"
363 test_expect_success
() {
364 test "$#" = 3 && { prereq
=$1; shift; } || prereq
=
366 error
"bug in the test script: not 2 or 3 parameters to test-expect-success"
369 say
>&3 "expecting success: $2"
371 if [ "$?" = 0 -a "$eval_ret" = 0 ]
381 test_expect_code
() {
382 test "$#" = 4 && { prereq
=$1; shift; } || prereq
=
384 error
"bug in the test script: not 3 or 4 parameters to test-expect-code"
387 say
>&3 "expecting exit code $1: $3"
389 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
399 # test_external runs external test scripts that provide continuous
400 # test output about their progress, and succeeds/fails on
401 # zero/non-zero exit code. It outputs the test output on stdout even
402 # in non-verbose mode, and announces the external script with "* run
403 # <n>: ..." before running it. When providing relative paths, keep in
404 # mind that all scripts run in "trash directory".
405 # Usage: test_external description command arguments...
406 # Example: test_external 'Perl API' perl ../path/to/test.pl
408 test "$#" = 4 && { prereq
=$1; shift; } || prereq
=
410 error
>&5 "bug in the test script: not 3 or 4 parameters to test_external"
413 if ! test_skip
"$descr" "$@"
415 # Announce the script to reduce confusion about the
416 # test output that follows.
417 say_color
"" " run $test_count: $descr ($*)"
418 # Run command; redirect its stderr to &4 as in
419 # test_run_, but keep its stdout on our stdout even in
426 test_failure_
"$descr" "$@"
431 # Like test_external, but in addition tests that the command generated
432 # no output on stderr.
433 test_external_without_stderr
() {
434 # The temporary file has no (and must have no) security
436 tmp
="$TMPDIR"; if [ -z "$tmp" ]; then tmp
=/tmp
; fi
437 stderr
="$tmp/git-external-stderr.$$.tmp"
438 test_external
"$@" 4> "$stderr"
439 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
440 descr
="no stderr: $1"
442 say
>&3 "expecting no stderr from previous command"
443 if [ ! -s "$stderr" ]; then
447 if [ "$verbose" = t
]; then
448 output
=`echo; echo Stderr is:; cat "$stderr"`
452 # rm first in case test_failure exits.
454 test_failure_
"$descr" "$@" "$output"
458 # This is not among top-level (test_expect_success | test_expect_failure)
459 # but is a prefix that can be used in the test script, like:
461 # test_expect_success 'complain and die' '
463 # do something else &&
464 # test_must_fail git checkout ../outerspace
467 # Writing this as "! git checkout ../outerspace" is wrong, because
468 # the failure could be due to a segv. We want a controlled failure.
472 test $?
-gt 0 -a $?
-le 129 -o $?
-gt 192
475 # test_cmp is a helper function to compare actual and expected output.
476 # You can use it like:
478 # test_expect_success 'foo works' '
479 # echo expected >expected &&
481 # test_cmp expected actual
484 # This could be written as either "cmp" or "diff -u", but:
485 # - cmp's output is not nearly as easy to read as diff -u
486 # - not all diff versions understand "-u"
492 # Most tests can use the created repository, but some may need to create more.
493 # Usage: test_create_repo <directory>
494 test_create_repo
() {
496 error
"bug in the test script: not 1 parameter to test-create-repo"
500 cd "$repo" || error
"Cannot setup test environment"
501 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
502 error
"cannot run git init -- have you built things yet?"
503 mv .git
/hooks .git
/hooks-disabled
509 test_results_dir
="$TEST_DIRECTORY/test-results"
510 mkdir
-p "$test_results_dir"
511 test_results_path
="$test_results_dir/${0%.sh}-$$"
513 echo "total $test_count" >> $test_results_path
514 echo "success $test_success" >> $test_results_path
515 echo "fixed $test_fixed" >> $test_results_path
516 echo "broken $test_broken" >> $test_results_path
517 echo "failed $test_failure" >> $test_results_path
518 echo "" >> $test_results_path
520 if test "$test_fixed" != 0
522 say_color pass
"fixed $test_fixed known breakage(s)"
524 if test "$test_broken" != 0
526 say_color error
"still have $test_broken known breakage(s)"
527 msg
="remaining $(($test_count-$test_broken)) test(s)"
529 msg
="$test_count test(s)"
531 case "$test_failure" in
533 say_color pass
"passed all $msg"
535 test -d "$remove_trash" &&
536 cd "$(dirname "$remove_trash")" &&
537 rm -rf "$(basename "$remove_trash")"
542 say_color error
"failed $test_failure among $msg"
548 # Test the binaries we have just built. The tests are kept in
549 # t/ subdirectory and are run in 'trash directory' subdirectory.
550 TEST_DIRECTORY
=$
(pwd)
551 if test -z "$valgrind"
553 if test -z "$GIT_TEST_INSTALLED"
555 PATH
=$TEST_DIRECTORY/..
:$PATH
556 GIT_EXEC_PATH
=$TEST_DIRECTORY/..
558 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
559 error
"Cannot run git from $GIT_TEST_INSTALLED."
560 PATH
=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..
:$PATH
561 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
566 test "$1" = "$(readlink "$2")" ||
{
574 while test -d "$2".lock
576 say
"Waiting for lock on $2."
583 make_valgrind_symlink
() {
584 # handle only executables
585 test -x "$1" ||
return
587 base
=$
(basename "$1")
588 symlink_target
=$TEST_DIRECTORY/..
/$base
589 # do not override scripts
590 if test -x "$symlink_target" &&
591 test ! -d "$symlink_target" &&
592 test "#!" != "$(head -c 2 < "$symlink_target")"
594 symlink_target
=..
/valgrind.sh
598 symlink_target
=..
/unprocessed-script
600 # create the link, or replace it if it is out of date
601 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
604 # override all git executables in TEST_DIRECTORY/..
605 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
606 mkdir
-p "$GIT_VALGRIND"/bin
607 for file in $TEST_DIRECTORY/..
/git
* $TEST_DIRECTORY/..
/test-
*
609 make_valgrind_symlink
$file
615 ls "$path"/git-
* 2> /dev
/null |
618 make_valgrind_symlink
"$file"
622 PATH
=$GIT_VALGRIND/bin
:$PATH
623 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
626 GIT_TEMPLATE_DIR
=$
(pwd)/..
/templates
/blt
628 GIT_CONFIG_NOSYSTEM
=1
629 GIT_CONFIG_NOGLOBAL
=1
630 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
632 GITPERLLIB
=$
(pwd)/..
/perl
/blib
/lib
:$
(pwd)/..
/perl
/blib
/arch
/auto
/Git
634 test -d ..
/templates
/blt ||
{
635 error
"You haven't built things yet, have you?"
638 if ! test -x ..
/test-chmtime
; then
639 echo >&2 'You need to build test-chmtime:'
640 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
644 . ..
/GIT-BUILD-OPTIONS
647 test="trash directory.$(basename "$0" .sh)"
648 test ! -z "$debug" || remove_trash
="$TEST_DIRECTORY/$test"
651 echo >&5 "FATAL: Cannot prepare test area"
655 test_create_repo
"$test"
656 # Use -P to resolve symlinks in our working directory so that the cwd
657 # in subprocesses like git equals our $PWD (for pathname comparisons).
658 cd -P "$test" ||
exit 1
661 this_test
=${this_test%%-*}
662 for skp
in $GIT_SKIP_TESTS
665 for skp
in $GIT_SKIP_TESTS
674 say_color skip
>&3 "skipping test $this_test altogether"
675 say_color skip
"skip all tests in $this_test"
680 # Fix some commands on Windows
683 # Windows has its own (incompatible) sort and find
693 # git sees Windows-style pwd
697 # no POSIX permissions
698 # backslashes in pathspec are converted to '/'
699 # exec does not inherit the PID
702 test_set_prereq POSIXPERM
703 test_set_prereq BSLASHPSPEC
704 test_set_prereq EXECKEEPSPID
708 test -z "$NO_PERL" && test_set_prereq PERL
710 # test whether the filesystem supports symbolic links
711 ln -s x y
2>/dev
/null
&& test -h y
2>/dev
/null
&& test_set_prereq SYMLINKS